/* Time:2021.4.16
Author:Chall
Version:V1.0 */

//为避免冲突，将我们的方法用一个匿名方法包裹起来
;(function($,window,document,undefined){
	//定义chSlider的构造函数
	var LanAudio = function(ele, opt) {
		this.$element = ele,
		this.defaults = {
			'audId':"audwrap",
			//'audiocId':"",
			'audiotitle':"",
			'audiosrc':"",
			'audind':1,
			'duration':90.1485
		},
		this.options = $.extend({}, this.defaults, opt)
	}
	//定义chSlider的方法
	LanAudio.prototype = {
		initAudio: function (doc, win) {
			Audio = this;
			var element = this.$element;
			options = this.options;

			// //console.log(element,options)
			// var w = $(window).width();
			// var h = $(window).height();
			// $("html").css({fontSize: w / 375 * 50 + "px"});

			var oL,oT,nomove,rate2,rate,oLeft,oTop,mvflag,oldleft=0,oddcmt=1;
			var total_time = options.duration;//视频总时长


			// 动态加载css文件
			// function loadStyles(url) {
			// 	var link = document.createElement("link");
			// 	link.type = "text/css";
			// 	link.rel = "stylesheet";
			// 	link.href = url;
			// 	document.getElementsByTagName("head")[0].appendChild(link);
			// }
			// loadStyles("http://o.cztvcloud.com/181/8622042/images/style_tt.css");

			// var html='<span class="audbtn"></span>' +
			// 	'<div class="audinner"><span class="audtitle">'+options.audiotitle+'</span></div>' +
			// 	'<div class="audjdt"><span class="audline"></span><div class="audtime" id="audjdt"><span class="audcur">00:00</span>/<span class="audtotal">00:00</span></div></div>' +
			// 	'<audio id="audsrc" src="'+options.audiosrc+'" style="display: none;"></audio>';
			var html='<span class="audbtn"></span>' +
				'<div class="audinner"><span class="audtitle">'+options.audiotitle+'</span></div>' +
				'<div class="audjdt"><span class="audline"></span><div class="audtime" id="audjdt'+options.audind+'"><span class="audcur">00:00</span>/<span class="audtotal">00:00</span></div></div>' +
				'<audio id="audio'+options.audind+'" src="'+options.audiosrc+'" style="display: none;"></audio>';

			element.append(html);

			//字符超出滚动
			Audio.textcheck(element);


			var myvObj = element.find("audio")[1];

			// myvObj.oncanplay = function () {
			//
			// }

			element.find(".audbtn").click(function(){
				$('audio').trigger('pause');
				//console.log(myvObj)
				element = $(this).parent(".audwrap");//to delete
				myvObj = element.find("audio")[1];


				if($(this).hasClass("played")){//暂停
					//$(".audbtn").addClass("played");
					$(this).removeClass("played")
					myvObj.pause();
				}else{
					$(".audbtn").removeClass("played");
					$(this).addClass("played")
					myvObj.play();
				}
			})

			if(total_time > 3600) element.find(".audcur").html("00:00:00");
			element.find(".audtotal").html(Audio.calculate(total_time));
			myvObj.addEventListener("ended", function () {
				console.log("video end...")
				if(!mvflag){
					//rate = rate2 = 0;
					//myvObj.currentTime = rate;
					myvObj.currentTime = 0;

					myvObj.pause();
					element.find(".audbtn").removeClass("played")
				}

			});
			//显示当前播放时间
			var fff = parseInt(element.find(".audjdt").width())-parseInt(element.find(".audtime").width())*0.7;
			myvObj.addEventListener('timeupdate',function(){
				current_time = this.currentTime;
				element = $(this).parent(".audwrap");

				element.find(".audcur").html(Audio.calculate(current_time));
				//console.log("timeupdate...",myvObj,element)

				//显示当前播放进度条
				var new_width = (current_time/total_time)*fff;
				//console.log(new_width)

				element.find(".audtime").css("left",new_width);

			})

			jdtItem = element.find(".audtime")[0];
			var cirW = jdtItem.offsetWidth/2;
			w = $(window).width();
			var w2 = element.find(".audtime").width();

			//移动端进度条拖动
			jdtItem.addEventListener('touchstart',function(e){
				//e.returnValue = true;
				// element = jdtItem.parent(".audwrap");//to delete
				// myvObj = element.find("audio")[1];
				var ev = e || window.event;
				var touch = ev.targetTouches[0];
				//oL = touch.clientX - durationIcon.offsetLeft - progress.offsetLeft;//鼠标相对于拖拽圆点的偏移距离
				oL = touch.clientX;//鼠标相对于拖拽圆点的偏移距离
				oT = touch.clientY;//鼠标相对于拖拽圆点的偏移距离
				nomove = true;
				rate2 = myvObj.currentTime;

				oldleft = rate2/myvObj.duration*fff;
				console.log("touchstart...",myvObj.currentTime,myvObj.duration,oldleft)

				$(".audbtn").removeClass("played")
				$('audio').trigger('pause');


				//$(".playbtn").fadeOut();
				//console.log("start...",element2.html())
			})
			jdtItem.addEventListener('touchmove',function(e){
				mvflag = true;
				var ev = e || window.event;
				var touch = ev.targetTouches[0];
				//var oLeft = touch.clientX - progress.offsetLeft - oL ; //滑块最左端距离父元素最左端的距离
				oLeft = touch.clientX - oL; //滑块最左端距离父元素最左端的距离
				oTop = touch.clientY - oT; //滑块最左端距离父元素最左端的距离

				$(".audbtn").removeClass("played")
				element.find(".audbtn").addClass("played")

				if(Math.abs(oLeft) > Math.abs(oTop)){//左右滑动
					// if(Math.abs(oLeft) > Math.abs(oTop) && Math.abs(oTop)<=15){//左右滑动
					nomove = false;
					e.preventDefault();

					myvObj.pause();

					element.find(".audtime").css("left",oLeft + oldleft);
					if(oLeft + oldleft<0) element.find(".audtime").css("left",0);
					else if(oLeft + oldleft >= fff ) element.find(".audtime").css("left",fff);
					myvObj.currentTime = (oLeft + oldleft)/fff*myvObj.duration;

					//console.log(oldleft,fff,myvObj.duration,oLeft,element)
				}else{//上下或没滑动
					nomove = true;
				}
			})
			//拖动结束时的处理
			jdtItem.addEventListener('touchend', function(e) {
				e.preventDefault();
				//console.log("ending oLeft",nomove)
				//oldleft = oLeft;
				oddcmt=2;
				oldleft = element.find(".audtime").css("left");
				console.log("touchend...",oLeft,oldleft,fff)

				if(!nomove){
					//oldleft = oLeft;

					if(oLeft < fff){
						mvflag = false;
						//rate2 = rate;
						//myvObj.currentTime = (oLeft + oldleft)/fff*myvObj.duration;
						myvObj.play();
					}else{
						//rate = rate2 = 0;
						//myvObj.currentTime =rate;
						myvObj.currentTime =0;
						myvObj.pause();
						element.find(".audbtn").removeClass("played")
					}

					document.removeEventListener("touchmove", function(e){
						e.preventDefault();
					});
				}
			});


			// element.find(".stopbtn").click(function(){
			// 	Audio.audstop(element);
			// })
			// element.find(".notebtn").click(function(){
			// 	Audio.audnote(element);
			// })
		},
		textcheck:function(element){
			var inner = element.find(".audinner").width();
			var pwid = element.find(".audtitle").width();
			var pleft=0;
			var plflag=true;
			if(pwid > inner){
				setInterval(function(){
					if(!plflag) return;

					if(pleft > (pwid - inner)){//重置
						plflag=false;
						setTimeout(function(){plflag=true;},2000)
						pleft = 0;
					}else{
						pleft++;
						element.find(".audtitle").css("left",-pleft)
					}
				},30)
			}
		},
		calculate:function(ttt){
			if(ttt > 3600){
				_h = parseInt(ttt/3600); //时
				_m = parseInt(ttt%3600/60); //分
				_s = parseInt(ttt%60); //秒

				_h = _h >= 10 ? _h : "0"+_h;
				_m = _m >= 10 ? _m : "0"+_m;
				_s = _s >= 10 ? _s : "0"+_s;

					return (_h+":"+_m + ":" + _s);
			}else{
				_m = parseInt(ttt/60); //分
				_s = parseInt(ttt%60); //秒

				_m = _m >= 10 ? _m : "0"+_m;
				_s = _s >= 10 ? _s : "0"+_s;

				return (_m + ":" + _s);
			}
		}
	}
	$.fn.extend({
		//方法
		audstop:function(element){
			element.find("audsrc")[0].pause();
			element.find(".audbtn").removeClass("played")
		},
		audnote:function(){
			var div = '<div class="tips_wrap actived">' +
				'    <div class="tips">' +
				'        <span class="newnote">您正在使用移动网络，可能产生较高的流量费用</span>' +
				'        <div class="newsdiv" style="position:absolute;bottom:0;">' +
				'            <span class="btncancle" style="position:relative;">取消</span>' +
				'            <span class="btngo" style="position:relative">确定</span>' +
				'        </div>' +
				'    </div>' +
				'</div>'

			$("body").append(div);
			$(".tips_wrap").show();
			$('.tips').show();
			$('.tips_wrap').css({'background':'rgba(0,0,0,0.4)','z-index':99999});

			$(".btncancle").click(function(){
				$(".tips_wrap,.tips").hide();
				$('.tips_wrap').css({'background':'rgba(0,0,0,0.4)','z-index':-1});
				document.getElementById("audsrc").pause();
				$(".audbtn").removeClass("played")
			})
			$(".btngo").click(function(){
				$(".tips_wrap,.tips").hide();
				$('.tips_wrap').css({'background':'rgba(0,0,0,0.4)','z-index':-1});
			})

		}
	})
	//在插件中使用chSlider对象
	$.fn.lanAudio = function(options) {
		//创建Beautifier的实体
		//alert(this.attr("id"))
		var _lanAudio = new LanAudio(this, options);
		//调用其方法
		return _lanAudio.initAudio();
	}	
	
})(jQuery,window,document);